This project is only in the beginning, therefore probably the following suggestions could be useful to understand how to improve this project and implement new features. 

\begin{itemize}
	\item \textbf{Debug semihosting console log}: it seems that the LPC1768 doesn't support the semihosting console. The semihosting is a console that is launched when you run a debug session with a debugger tool and by default the \verb|printf| function and all correlated functions in \textbf{stdio} library are mapped in this console. This console is very useful for debug and we needs to check in deep if it is possible to enable it in our LPC1768. In alternative you can configure and initialize a UART serial, connect it to you PC through a USB cable and define a \verb|printf| and \verb|scanf|  function mapped to the read and write functionalities on the UART. However it's better to use a UART not for the debug logs but for a shell command line interface used to control the platform through serial cable, but if your device has 2 configurable UART port, as LPC1768 has you can use one for console log and the other for the shell. If you have a different board, check whether you can configure the semihosting console and if the \verb|printf| function on it. When you find a way to be able to use the \verb|printf| function, you can use \textit{log.h} header, that is a simple log library  implementation with different log levels that can be configured at compile time.
	
	\verb|DEBUG=1| $\longrightarrow$ Enables debug logs
	
	\verb|LOG_LEVEL=<level>| $\longrightarrow$ Specifies the maximum log level to be printed.
	
	\begin{itemize}
		\item \verb|LOG (const char *, ...)|: log level always printed (level=0).
		\item \verb|LOGE(const char *, ...)|: error logs (level=1).
		\item \verb|LOGW(const char *, ...)|: warning logs (level=2).
		\item \verb|LOGI(const char *, ...)|: informational logs (level=3).
		\item \verb|LOGD(const char *, ...)|: debug logs (level=4).
	\end{itemize}
	\item \textbf{CLI}: implementation of a shell command line interface configured on a UART serial port. FreeRTOS provides a simple, small, extensible and RAM efficient method of enabling your application to process command line input, that is the  \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_CLI/FreeRTOS_Plus_Command_Line_Interface.html}{FreeRTOS+CLI} library. There are lot of documentation and examples code for this library, it is really light and easy to use. Moreover FreeRTOS+CLI doesn't need a porting and it is ready to use.
	\item \textbf{Filesystem}: in many platform you can use an SPI/UART port for a microSD card slot and uses it for the filesystem. For example the LPC1768 has 2 SPI/UART port and one of this could be used for the microSD. FreeRTOS implemented a scalable FAT12, FAT16, FAT32 DOS, Windows compatible embedded FAT file system, that is the \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_FAT/index.html}{FreeRTOS+FAT} library. This extension uses the standard API for filesystem (\verb|fopen()|, \verb|fread()|, \verb|fwrite()|...) and it needs a porting, because it needs to know where the filesystem is mounted. If you want you can decide to configure the FreeRTOS+FAT filesystem in the RAM memory of the platform, if you don't have a micro SD card slot it could be a nice test to do. 
	\item \textbf{Real-time application}: work in progress with G. Pravadelli professor. 
	\item \textbf{Threading}: could be really interesting to develop thread application built over the FreeRTOS mutitasking system. FreeRTOS implemented the Portable Operating System Interface (POSIX), a family of standards specified by the IEEE, for threading into an extension called \href{https://www.freertos.org/FreeRTOS-Plus/FreeRTOS_Plus_POSIX/index.html}{FreeRTOS+POSIX}. Therefore you can take an existing POSIX threading compliant application and run on the FreeRTOS kernel. The library doesn't need a real porting, it requires only a configuration of the existing porting files, that in general does not need any change. The real-time FreeRTOS multitasking and related real-time applications could be extended with POSIX thread, trying to keep some real-time constraints.
\end{itemize}